
IF(WIN32)
    FIND_PATH(OSGEO4W_ROOT NAMES OSGeo4W.bat PATHS $ENV{OSGEO4W_ROOT} )
	IF(OSGEO4W_ROOT)
		MESSAGE(STATUS "Found OSGeo4W : ${OSGEO4W_ROOT}")
		SET(OSGEO4W_FOUND TRUE)
		SET(OSGEO4W_ROOT ${OSGEO4W_ROOT} )
		SET(OSGEO4W_INCLUDE ${OSGEO4W_ROOT}/include )
	    SET(OSGEO4W_LIB ${OSGEO4W_ROOT}/lib )
		
		FIND_PATH(GDAL_INCLUDE_DIR NAMES gdal.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(GDAL_LIBRARY NAMES gdal_i PATHS ${OSGEO4W_LIB})
		IF(NOT GDAL_INCLUDE_DIR OR NOT GDAL_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but GDAL is not found : Please install the 'gdal' package from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(GEOTIFF_INCLUDE_DIR NAMES geotiff.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(GEOTIFF_LIBRARY NAMES geotiff_i PATHS ${OSGEO4W_LIB})
		IF(NOT GEOTIFF_INCLUDE_DIR OR NOT GEOTIFF_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but GeoTIFF is not found : Please install the 'libgeotiff' package from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(TIFF_INCLUDE_DIR NAMES tiffio.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(TIFF_LIBRARY NAMES libtiff_i PATHS ${OSGEO4W_LIB})
		IF(NOT TIFF_INCLUDE_DIR OR NOT TIFF_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but TIFF is not found : Please install the 'libtiff' and 'libtiff-devel' package from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(JPEG_INCLUDE_DIRS NAMES jpeglib.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(JPEG_LIBRARY NAMES jpeg_i PATHS ${OSGEO4W_LIB})
		IF(NOT JPEG_INCLUDE_DIRS OR NOT JPEG_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but JPEG is not found : Please install the 'libjpeg' package from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(PNG_PNG_INCLUDE_DIR NAMES png.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(PNG_LIBRARY NAMES libpng13 PATHS ${OSGEO4W_LIB})
		IF(NOT PNG_PNG_INCLUDE_DIR OR NOT PNG_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but PNG is not found : Please install the 'libpng' and 'libpng-devel-vc' packages from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(ZLIB_INCLUDE_DIR NAMES zlib.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(ZLIB_LIBRARY NAMES zlib PATHS ${OSGEO4W_LIB})
		IF(NOT ZLIB_INCLUDE_DIR OR NOT ZLIB_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but ZLIB is not found : Please install the 'zlib' and 'zlib-devel' packages from the OSGeo4W Setup")
		ENDIF()
		
		FIND_PATH(EXPAT_INCLUDE_DIR NAMES expat.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(EXPAT_LIBRARY NAMES libexpat PATHS ${OSGEO4W_LIB})
		IF(NOT EXPAT_INCLUDE_DIR OR NOT EXPAT_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but Expat is not found : Please install the 'expat' package from the OSGeo4W Setup")
		ENDIF()
	
		FIND_PATH(CURL_INCLUDE_DIR NAMES curl/curl.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(CURL_LIBRARY NAMES libcurl_imp PATHS ${OSGEO4W_LIB})
		IF(NOT CURL_INCLUDE_DIR OR NOT CURL_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but Curl is not found : Please install the 'curl' package from the OSGeo4W Setup")
		ENDIF()

		FIND_PATH(LIBLAS_INCLUDE_DIR NAMES liblas/capi/liblas.h PATHS ${OSGEO4W_INCLUDE})
		FIND_LIBRARY(LIBLAS_LIBRARY NAMES liblas_c PATHS ${OSGEO4W_LIB})
		IF(NOT LIBLAS_INCLUDE_DIR OR NOT LIBLAS_LIBRARY)
		  MESSAGE(WARNING "OSGeo4W found but LibLAS is not found : Please install the 'liblas' and 'liblas-devel' package from the OSGeo4W Setup")
		ENDIF()
	
	ELSE(OSGEO4W_ROOT)
		MESSAGE(STATUS "Could not find OSGeo4W")
		SET(OSGEO4W_FOUND FALSE)
	ENDIF(OSGEO4W_ROOT)
ELSE(WIN32)
	SET(OSGEO4W_FOUND FALSE)
ENDIF(WIN32)