FIND_PACKAGE(Mercurial)
IF(Mercurial_FOUND)
  MESSAGE(STATUS "Repository status :")
  Mercurial_WC_IDENTIFY(${PROJECT_SOURCE_DIR} OTB)
  MESSAGE(STATUS "  Mercurial version is ${Mercurial_VERSION_HG}")
  MESSAGE(STATUS "  Repository revision is ${OTB_WC_REVISION}")
  SET(OTB_WC_REVISION ${OTB_WC_REVISION} CACHE STRING "Repository version" FORCE)
  MARK_AS_ADVANCED(OTB_WC_REVISION)
  IF(OTB_WC_STATUS)
    MESSAGE(STATUS "  Local file modifications:")
    STRING(REPLACE "\n" "\n--     " OTB_WC_STATUS_PRETTYPRINT "    ${OTB_WC_STATUS}")
    MESSAGE(STATUS "${OTB_WC_STATUS_PRETTYPRINT}")
  ELSE(OTB_WC_STATUS)
    MESSAGE(STATUS "  No files modified locally")
  ENDIF(OTB_WC_STATUS)
  STRING(REGEX REPLACE "\n" ";" OTB_WC_STATUS "${OTB_WC_STATUS}")
  SET(OTB_WC_STATUS ${OTB_WC_STATUS} CACHE STRING "Repository status" FORCE)
  MARK_AS_ADVANCED(OTB_WC_STATUS)
  
  IF(OTB_DATA_ROOT)
    Mercurial_WC_IDENTIFY(${OTB_DATA_ROOT} OTB_DATA)
    SET(OTB_DATA_WC_REVISION ${OTB_DATA_WC_REVISION} CACHE STRING "Repository version" FORCE)
    MARK_AS_ADVANCED(OTB_DATA_WC_REVISION)
  ENDIF(OTB_DATA_ROOT)
  
ENDIF(Mercurial_FOUND)
